### 4.11 `ld` and PowerPC64 64-bit ELF Support

`--stub-group-size`
  Long branch stubs, PLT call stubs and TOC adjusting stubs are placed by `ld` in stub sections located between groups of input sections. ‘`--stub-group-size`’ specifies the maximum size of a group of input sections handled by one stub section. Since branch offsets are signed, a stub section may serve two groups of input sections, one group before the stub section, and one group after it. However, when using conditional branches that require stubs, it may be better (for branch prediction) that stub sections only serve one group of input sections. A negative value for ‘`N`’ chooses this scheme, ensuring that branches to stubs always use a negative offset. Two special values of ‘`N`’ are recognized, ‘`1`’ and ‘`-1`’. These both instruct `ld` to automatically size input section groups for the branch types detected, with the same behaviour regarding stub placement as other positive or negative values of ‘`N`’ respectively.

  Note that ‘`--stub-group-size`’ does not split input sections. A single input section larger than the group size specified will of course create a larger group (of one section). If input sections are too large, it may not be possible for a branch to reach its stub.

`--emit-stub-syms`
  This option causes `ld` to label linker stubs with a local symbol that encodes the stub type and destination.

`--dotsyms, --no-dotsyms`
  These two options control how `ld` interprets version patterns in a version script. Older PowerPC64 compilers emitted both a function descriptor symbol with the same name as the function, and a code entry symbol with the name prefixed by a dot (‘`.`’). To properly version a function ‘`foo`’, the version script thus needs to control both ‘`foo`’ and ‘`.foo`’. The option ‘`--dotsyms`’, on by default, automatically adds the required dot-prefixed patterns. Use ‘`--no-dotsyms`’ to disable this feature.

`--no-tls-optimize`
  PowerPC64 `ld` normally performs some optimization of code sequences used to access Thread-Local Storage. Use this option to disable the optimization.

`--no-opd-optimize`
  PowerPC64 `ld` normally removes `.opd` section entries corresponding to deleted link-once functions, or functions removed by the action of ‘`--gc-sections`’ or linker script `/DISCARD/`. Use this option to disable `.opd` optimization.

`--non-overlapping-opd`
  Some PowerPC64 compilers have an option to generate compressed `.opd` entries spaced 16 bytes apart, overlapping the third word, the static chain pointer (unused in C) with the first word of the next entry. This option expands such entries to the full 24 bytes.

`--no-toc-optimize`
  PowerPC64 `ld` normally removes unused `.toc` section entries. Such entries are detected by examining relocations that reference the TOC in code sections. A reloc in a deleted code section marks a TOC word as unneeded, while a reloc in a kept code section marks a TOC word as needed. Since the TOC may reference itself, TOC relocs are also examined. TOC words marked as both needed and unneeded will of course be kept. TOC words without any referencing reloc are assumed to be part of a multi-word entry, and are kept or discarded as per the nearest marked preceding word. This works reliably for compiler generated code, but may be incorrect if assembly code is used to insert TOC entries. Use this option to disable the optimization.

`--no-multi-toc`
  If given any toc option besides `-mcmodel=medium` or `-mcmodel=large`, PowerPC64 GCC generates code for a TOC model where TOC entries are accessed with a 16-bit offset from r2. This limits the total TOC size to 64K. PowerPC64 `ld` extends this limit by grouping code sections such that each group uses less than 64K for its TOC entries, then inserts r2 adjusting stubs between inter-group calls. `ld` does not split apart input sections, so cannot help if a single input file has a `.toc` section that exceeds 64K, most likely from linking multiple files with `ld -r`. Use this option to turn off this feature.

`--no-toc-sort`
  By default, `ld` sorts TOC sections so that those whose file happens to have a section called `.init` or `.fini` are placed first, followed by TOC sections referenced by code generated with PowerPC64 gcc's `-mcmodel=small`, and lastly TOC sections referenced only by code generated with PowerPC64 gcc's `-mcmodel=medium` or `-mcmodel=large` options. Doing this results in better TOC grouping for multi-TOC. Use this option to turn off this feature.

`--plt-align`
`--no-plt-align`
  Use these options to control whether individual PLT call stubs are aligned to a 32-byte boundary, or to the specified power of two boundary when using `--plt-align=`. By default PLT call stubs are packed tightly.

`--plt-static-chain`
`--no-plt-static-chain`
  Use these options to control whether PLT call stubs load the static chain pointer (r11). `ld` defaults to not loading the static chain since there is never any need to do so on a PLT call.

`--plt-thread-safe`
`--no-thread-safe`
  With power7's weakly ordered memory model, it is possible when using lazy binding for ld.so to update a plt entry in one thread and have another thread see the individual plt entry words update in the wrong order, despite ld.so carefully writing in the correct order and using memory write barriers. To avoid this we need some sort of read barrier in the call stub, or use LD_BIND_NOW=1. By default, `ld` looks for calls to commonly used functions that create threads, and if seen, adds the necessary barriers. Use these options to change the default behaviour.